#!/bin/bash
# SPDX-Version: 3.0
# SPDX-CreationInfo: 2025-06-17; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-ExternalRef: GIT https://git.coresecret.dev/msw/CISS.debian.installer.git
# SPDX-FileContributor: WEIDNER, Marc S.; Centurion Intelligence Consulting Agency
# SPDX-FileCopyrightText: 2024-2025; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-FileType: SOURCE
# SPDX-License-Identifier: EUPL-1.2 OR LicenseRef-CCLA-1.0
# SPDX-LicenseComment: This file is part of the CISS.debian.installer.secure framework.
# SPDX-PackageName: CISS.debian.installer
# SPDX-Security-Contact: security@coresecret.eu

guard_sourcing

#######################################
# Install a minimal Debian environment using the 'debootstrap' command.
# Globals:
#   ERR_DEBOOTSTRAP
#   LOG_DBS
#   TARGET
#   VAR_ARCHITECTURE
#   VAR_CODENAME
#   debootstrap_includes
#   debootstrap_mirror
# Arguments:
#   None
# Returns:
#   0: on success
#   ERR_DEBOOTSTRAP
#######################################
func_debootstrap() {
  ### Declare Arrays, HashMaps, and Variables.
  declare -r var_arch="${VAR_ARCHITECTURE}"
  declare -r var_dist="${VAR_CODENAME}"
  declare -r var_target="${TARGET}"
  declare -r var_mirror="${debootstrap_mirror}"
  declare -r var_includes="${debootstrap_includes}"
  declare -a ary_cmd=()

  ary_cmd+=( "debootstrap" "--arch=${var_arch}" )

  if [[ -n "${var_includes}" ]]; then ary_cmd+=( "--include=${var_includes}" ); fi

  ary_cmd+=( "${var_dist}" "${var_target}" "${var_mirror}" )

  do_log "debug" "file_only" "4000() Executing: [${ary_cmd[*]}]"

  # shellcheck disable=SC2312
  if "${ary_cmd[@]}" | tee "${LOG_DBS}"; then

    do_log "info" "file_only" "4000() [${ary_cmd[*]}] successful."
    install -d -m 0700 -o root -g root "${var_target}/root/.ciss/cdi/backup"
    install -d -m 0700 -o root -g root "${var_target}/root/.ciss/cdi/log"
    install -d -m 0700 -o root -g root "${var_target}/root/.ciss/cdi/hooks"
    guard_dir && return 0

  else

    do_log "emergency" "file_only" "4000() [${ary_cmd[*]}] failed."
    return "${ERR_DEBOOTSTRAP}"

  fi
}
# vim: number et ts=2 sw=2 sts=2 ai tw=128 ft=sh
